"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Account = void 0;
const common_1 = require("../common");
const account_created_event_1 = require("./account-created.event");
const constants_1 = require("./constants");
class Account extends (0, common_1.Aggregate)(constants_1.AggregateTypes.Account) {
    validateProps(props) { }
    static create(props) {
        const newAccount = common_1.AggregateBuilder.new(Account, props);
        newAccount.recordEvent(common_1.DomainEventBuilder.new(account_created_event_1.AccountCreatedEvent, newAccount.id, {
            accountId: newAccount.id,
            username: newAccount.username,
        }));
        return newAccount;
    }
    get username() {
        return this._props.username;
    }
}
exports.Account = Account;
